package com.eco.plugin.xx.hqctb.db.dao;

import com.eco.plugin.xx.hqctb.db.bean.DeptEntity;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.RestrictionFactory;
import java.util.List;

/**
 * @author xx
 * @version 10.0
 * Created by xx on 2021-12-03
 **/
public class DeptDao extends BaseDAO<DeptEntity> {

    public DeptDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<DeptEntity> getEntityClass() {
        return DeptEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return DeptEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return DeptDao.class;
        }
    };

    public void add(DeptEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void remove(String id) throws Exception {
        getSession().remove(QueryFactory.create()
                        .addRestriction(RestrictionFactory.eq("id", id)),
                this.getEntityClass());
    }

    public void update(DeptEntity entity) throws Exception {
        getSession().merge(entity);
    }


    public DeptEntity getByCode(String username) throws Exception {
        QueryCondition condition = QueryFactory.create()
                .addRestriction(RestrictionFactory.eq("CODE", username));

        return findOne(condition);
    }


    public List<DeptEntity> like(String pid, String type)throws Exception{
        QueryCondition condition = QueryFactory.create()
                .addRestriction(RestrictionFactory.like("", pid)).addRestriction(RestrictionFactory.like(DeptEntity.COLUMN_ID,type));
        return find(condition);
    }
}
