package com.eco.plugin.xx.hqctb.utils;

import org.apache.commons.dbcp2.BasicDataSourceFactory;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;

public class JDBCUtils {
    private static Properties properties = new Properties();
    private static DataSource dataSource;

    static{
        Properties pt = PropertiesUtils.getProperties2("/resources/db.properties");
        FRUtils.FRLogInfo("url:"+pt.getProperty("url"));
        properties.setProperty("driverClassName","com.mysql.jdbc.Driver");
        properties.setProperty("url",pt.getProperty("url"));
        properties.setProperty("username",pt.getProperty("username"));
        properties.setProperty("password",pt.getProperty("password"));
        properties.setProperty("initialSize","30");
        properties.setProperty("maxTotal","30");
        properties.setProperty("maxIdle","10");
        properties.setProperty("minIdle","5");
        properties.setProperty("maxWailMillis","1000");
        properties.setProperty("removeAbandonedOnMaintenance","true");
        properties.setProperty("removeAbandonedOnBorrow","true");
        properties.setProperty("removeAbandonedTimeout","300");
        try {
            dataSource = BasicDataSourceFactory.createDataSource(properties);
        } catch (Exception e) {
            FRUtils.FRLogError("创建链接池异常:"+e.getMessage());
        }


    }

    public static Connection getConnect(){
        Connection connection = null;

        try{
            connection = dataSource.getConnection();
        }catch(Exception e){
            FRUtils.FRLogError("获取数据库连接异常:"+e.getMessage());
        }

        return connection;
    }

    /**
     * 更新
     * @param sql
     * @return
     */
    public static int update(String sql){
        Connection conn=null;
        Statement st=null;
        int count = 0;

        try {
            conn = getConnect();
            st = conn.createStatement();
            count = st.executeUpdate(sql);

        } catch (SQLException e) {
            FRUtils.FRLogError("执行updata语句异常");
        } finally {
            release(conn, st, null);
        }

        return count;
    }

    private static void release(Connection conn, Statement st, ResultSet rs) {
        closeRs(rs);
        closeSt(st);
        closeConn(conn);
    }

    private static void closeRs(ResultSet rs) {
        try {
            if(rs!=null) {
                rs.close();
            }
        } catch (SQLException e) {
            FRUtils.FRLogError("关闭rs异常");
        } finally {
            rs=null;
        }

    }

    private static void closeSt(Statement st) {
        try {
            if(st!=null) {
                st.close();
            }
        } catch (SQLException e) {
            FRUtils.FRLogError("关闭st异常");
        } finally {
            st=null;
        }

    }

    private static void closeConn(Connection conn) {
        try {
            if(conn!=null) {
                conn.close();
            }
        } catch (SQLException e) {
            FRUtils.FRLogError("关闭connect异常");
        } finally {
            conn=null;
        }
    }

}
